function set_current_version() {
    $.ajax({
        type: 'GET',
        url: 'http://192.0.2.1:8080/version',
        dataType: 'json',
        timeout: 30000,
    }).then(
        function(data) {
            $("#current-version").text("Current version: " + (data.Version / 100).toFixed(2));
        },
        function(xhr) {
            console.info("connect error");
        }
        )
}

function check_update() {
    $.ajax({
        type: 'GET',
        url: 'http://192.0.2.1:8081/1/update',
        dataType: 'json',
        timeout: 30000,
        cache: false,
    }).then(
        function(data) {
            if (data.Status === 0) {
                $("#update-msg").text("Currently firmware version is latest.");
            }
            else {
                $("#do_update").removeAttr("disabled", "disabled");
                $("#update-msg").text("Version " + (data.Status / 100).toFixed(2) + " was found. Please update.");
            }
            $("#update-last-check-body").text(getNow());
        },
        function(xhr) {
            $("#update-msg").text("Failed to connect.");
            console.info("error connect");
        }
        )
}
function do_update() {
    $.ajax({
        type: 'PUT',
        url: 'http://192.0.2.1:8081/1/update',
        dataType: 'json',
        timeout: 300000,
    }).then(
        function(data) {
            if (data.Status === 0) {
                // アップデートできる確証がある上でバージョンの衝突が起きているのでエラー扱いにする
                $("#update-msg").html("Version conflict");
                $("#do_update").attr("disabled", "disabled");
            }
            else {
                $("#update-msg").html("Update successful(version " + (data.Status / 100).toFixed(2) + ")");
                $("#do_update").attr("disabled", "disabled");
                set_current_version();
            }
        },
        function(xhr) {
            $("#update-msg").html("Update failed");
        }
        )
}

$("#check_update").click(function() {
    $("#update-msg").html('<i class="fa fa-spinner fa-pulse" id="update-spinner"></i>');
    check_update();
});

$("#do_update").click(function() {
    $("#update-msg").html('<i class="fa fa-spinner fa-pulse" id="update-spinner"></i>');
    do_update();
});



// One-Line Resetボタン押下
$("#one-reset").click(function() {
    disabled_input_boxes();
});

// パラメータ異常を示すモーダルを閉じる時
$('#modal-oneline-param-invalid-close').click(function() {
    $('#modal-oneline-param-invalid').css('display', 'none');
});
// NeedleWork本体との通信が取れないモーダルを閉じる時(oneline)
$('#modal-oneline-unreachable-close').click(function() {
    $('#modal-oneline-unreachable').css('display', 'none');
});

function disabled_input_boxes() {
    $('#one-protocol').val('1');
    $('#one-srcfw').val('');
    $('#one-srcip').val('');
    $('#one-srcport').val('');
    $('#one-dstfw').val('');
    $('#one-dstip').val('');
    $('#one-dstport').val('');
    $('#one-nat-dstip').val('');
    $('#one-nat-dstport').val('');
}


// Updateクリック時
$(".sidebar-update").click(function() {
    $('.content-wrapper').css('display', 'none');
    $('#content-update').css('display', 'block');
    $('.sidebar-menu li').removeClass('active');
    $('.sidebar-menu #menu-update').addClass('active');
    set_current_version();
    if ($('#scenario-filename').val() === '') {//scenarioのcsvインポート中はApplyできない。
        $('#check_update').removeAttr('disabled','disabled');
    }
});
