//
//Test用 HTMLの挿入
//
var test_html = '\
    <div id="test">\
        <p>counter: <input type="num "id="counter" value="0" size="3"></p>\
        <div id="test-util">\
            <p>util</p>\
            <button id="count">clear count</button>\
            <button id="changeprotocol">change protocol</button>\
        </div>\
        <div id="oneline-scenario">\
            <p>scenario</p>\
            <button id="scenario-checkpass">checkpass</button>\
            <button id="scenario-checkdrop">check drop</button>\
            <button id="scenario-checkall">check all</button>\
            <button id="scenario-checkerrormismatch">check error mismatch</button>\
            <br>\
            <button id="scenario-checkclearbutton">check clear button</button>\
            <button id="scenario-checkplaypolicy">check play policy</button>\
            <button id="scenario-checkretrypolicy">check retry policy</button>\
        </div>\
        <div id="oneline-test">\
            <p>oneline</p>\
            <button id="icmpnormal">icmp normal</button>\
            <button id="tcpnormal">tcp normal</button>\
            <button id="udpnormal">udp normal</button>\
            <br>\
            <button id="invalidprotocol">invalid protocol</button>\
            <button id="invalidicmpnoprefix">invalid icmpi no prefix</button>\
            <button id="invalidtcpnoprefix">invalid tcp no prefix</button>\
            <button id="invalidudpnoprefix">invalid udp no prefix</button>\
            <br>\
            <button id="invalidicmpprefix">invalid icmp prefix</button>\
            <button id="invalidtcpprefix">invalid tcp prefix</button>\
            <button id="invalidudpprefix">invalid udp prefix</button>\
            <br>\
            <button id="invalidicmpport">invalid icmp port</button>\
            <button id="invalitcpdport">invalid tcp port</button>\
            <button id="invalidudpport">invalid udp port</button>\
        </div>\
        <div id="test-setting">\
            <p>setting(5秒くらいかかる)</p>\
            <button id="setting-normal">normal</button>\
            <button id="setting-invalid-eth0">invalid eth0</button>\
            <button id="setting-invalid-eth1">invalid eth1</button>\
            <button id="setting-invalid-eth2">invalid eth2</button>\
            <button id="setting-invalid-gateway">invalid gateway</button>\
            <button id="setting-invalid-dns">invalid dns</button>\
            <br>\
            <button id="setting-duplicate-ips">duplicate ip</button>\
        </div>\
    </div>\
    '
$(test_html).appendTo(".wrapper");

var oneline = $('<script type="text/javascript" src="./dist/js/test/oneline-test.js"></script>');
var scenario = $('<script type="text/javascript" src="./dist/js/test/scenaio-test.js"></script>');
var setting = $('<script type="text/javascript" src="./dist/js/test/setting-test.js"></script>');
var update = $('<script type="text/javascript" src="./dist/js/test/update-test.js"></script>');
$(oneline).appendTo("head");
$(scenario).appendTo("head");
$(setting).appendTo("head");
$(update).appendTo("head");

//
//テスト用cssの読み込み
//
var test_url = $('<link rel="stylesheet" href="./dist/css/test.css">')
$(test_url).appendTo(".main-footer");

//
//共通の関数
//
function TestResult(text, num) {
    if (typeof num === "undefined") { num = ""; }
    console.trace("result: ", text, " : ", num);
}
function Sleep(time, callback) {
    setTimeout(function() { eval(callback) }, time);
}
//
//Test用の汎用関数
//
Test = function(mode) {
    this.mode = null;
    this.invalid_no_prefix_ips = [
        "",
        "192.168.5.2/25",
        "192.168.0",
        "192.168111.1",
        "192.1688.0.1",
        "192.168.0.111.0/25",
        "192.168.0..1",
        "a92.168.0.２"
    ];
    this.invalid_prefix_ips = [
        "",
        "192.168.2.111",
        "192.168.2.111/33",
        "192.168..222/0",
        "192.168.2/25",
        "192.168222.1/25",
        "192.1688.2.1/25",
        "192.168.1.222.1/25",
        "192.168.2..1/25",
        "a92.168.2.２/25"
    ];
}
Test.prototype.isDisabled = function(selector) {
    //var bool = $("'"+selector + "'").is(":disabled");
    var bool = $(selector).is(":disabled");
    //console.log($(selector).prop(":disabled"));
    //console.log(bool);
    return bool;
}
Test.prototype.isDisplay = function(selector) {
    var bool = null;
    if ($(selector).css('display') === "none") {
        bool = false;
        //console.info("display: false :" + selector);
    } else if ($(selector).length == 0) {//タグが取得できないと空配列が返るため
        bool = false;
        //console.info("display: false :" + selector);
    } else {
        bool = true;
        //console.info("display: true :" + selector);
    }
    return bool;
}
Test.prototype.isDisplayElement = function(element) {//タグのオブジェクトそのものが引数
    if (element.css('display') === "none") {
        //console.info("display: false :" , element);
        return false;
    } else if (element.length == 0) {//タグが取得できないと空配列が返るため
        //console.info("display: false :" , element);
        return false;
    } else {
        //console.info("display: true :" , element);
        return true;
    }
}
Test.prototype.isCheck = function(selector) {//span(メッセージ表示領域)のid or iタグ自身のid
    if ($(selector).prop("tagName") == "I") {//iタグ自身が指定された場合
        if (this.isDisplay(selector)) {//表示状態かどうか
            //console.info("check: " + "false" + " : " + selector);
            return true;
        }
    } else if (this.isDisplay(selector + " > i")) {//spanタグの場合
        if ($(selector + " > i").hasClass("fa-check")) {//iタグがspinnerかcheckか
            //console.info("check: " + "true" + " : " + selector + "> i");
            return true;
        }
    } else { return false; }
}

Test.prototype.getButtonBesideMessage = function(selector) {//buttonの隣のspanタグ
    var text = "";
    if (this.isDisplay(selector)) {
        var msg_element = selector + "> span";
        if (this.isDisplay(msg_element)) {
            text = $(msg_element).text();
        } else {
            console.info("no message");
        }
    } else {
        console.error("not exit selector " + selector);
    }
    return text;
}


//for test button
var count = 0;
$("#count").click(function() {
    count = 0;
    $("#counter").val(count);
})
$("#changeprotocol").click(function() {
    var protocol = ["ICMP", "TCP", "UDP"];
    oneline.SelectProtocolName(protocol[count % 3]);
    console.info(protocol[count % 3]);
    ++count;
})
$("#counter").change(function() {
    count = parseInt($("#counter").val());
})
//counter更新用
setInterval(function(){$("#counter").val(count);},1000);
//for debug
var scenario_test = new Scenario();
var test = new Test();
var oneline_test = new OneLineTest();
var settings_test = new Settings();
//needleworkの設定を取ってくるために必要
$(".sidebar-settings").click();
setTimeout(function(){$(".sidebar-scenario").click();},1000);